%if 0%{?fedora} >= 17
%global	rubyabi	1.9.1
%global	header_dir	%{ruby_vendorarchdir}
%global	ruby19	1
%else
%global	ruby_sitelib	%(ruby -rrbconfig -e "puts Config::CONFIG['sitelibdir']")
%global	ruby_sitearch	%(ruby -rrbconfig -e "puts Config::CONFIG['sitearchdir']")

%global	rubyabi	1.8
%global	header_dir	%{ruby_sitearch}
%global	ruby19	0
%endif

%global	gem_name	goocanvas

%global	glibminver	1.1.4
%global	gtkminver	1.1.3
%global	obsoleteevr	0.90.7-1.999

Summary:	Ruby binding of GooCanvas
Name:		rubygem-%{gem_name}
Version:	1.1.5
Release:	1%{?dist}
Group:		Development/Languages
# from README
License:	LGPLv2
URL:		http://ruby-gnome2.sourceforge.jp/
Source0:	http://rubygems.org/gems/%{gem_name}-%{version}.gem

BuildRequires:	ruby(abi) = %{rubyabi}
BuildRequires:	rubygems-devel
BuildRequires:  rubygem-cairo-devel%{?_isa}
BuildRequires:	rubygem-gtk2-devel%{?_isa} >= %{gtkminver}
BuildRequires:	rubygem-gdk_pixbuf2-devel%{?_isa} >= %{gtkminver}
BuildRequires:	ruby-devel%{?_isa}
BuildRequires:	goocanvas-devel%{?_isa}
Requires:	ruby(abi) = %{rubyabi}
Requires:       rubygem(cairo)
Requires:	rubygem(gtk2) >= %{glibminver}
Provides:	rubygem(%{gem_name}) = %{version}
# Kill non-gem support on F-16+
# Obsoletes but not provides
%if 0%{?fedora} >= 16
Obsoletes:	ruby-%{gem_name} < %{version}-%{release}
%endif


%description
Ruby/GooCanvas is a Ruby binding of GooCanvas.

%package	doc
Summary:	Documentation for %{name}
Group:		Documentation
Requires:	%{name}%{?_isa} = %{version}-%{release}

%description	doc
This package contains documentation for %{name}.

%if 0%{?fedora} < 16
%package	-n ruby-%{gem_name}
# Non-gem support is only for < F-16
Summary:	Non-Gem support package for %{gem_name}
Group:		Development/Languages
Requires:	%{name}%{?_isa} = %{version}-%{release}
# Requires for corresponsing non-gem rpms
Requires:       ruby(cairo)
Requires:	ruby(gtk2)
Provides:	ruby(%{gem_name}) = %{version}-%{release}

%description	-n ruby-%{gem_name}
This package provides non-Gem support for %{gem_name}.
%endif

%package	devel
Summary:	Ruby/GooCanvas development environment
Group:		Development/Languages
Requires:	%{name}%{?_isa} = %{version}-%{release}
# Obsoletes / Provides
# ruby(%%{gem_name}-devel) Provides is for compatibility
# on F-15 and below
Obsoletes:	ruby-%{gem_name}-devel < %{obsoleteevr}
%if 0%{?fedora} < 16
Provides:	ruby-%{gem_name}-devel = %{version}-%{release}
Provides:	ruby(%{gem_name}-devel) = %{version}-%{release}
%endif

%description devel
Header files and libraries for building a extension library for the
rubygem-%{gem_name}

%prep
%setup -q -c -T
mkdir -p .%{gem_dir}

export CONFIGURE_ARGS="--with-cflags='%{optflags}'"
export CONFIGURE_ARGS="$CONFIGURE_ARGS --with-pkg-config-dir=$(pwd)%{_libdir}/pkgconfig"
gem install \
	-V \
	--local \
	--install-dir .%{gem_dir} \
	--force \
	--rdoc \
	%{SOURCE0}

find . -name \*.gem | xargs chmod 0644

pushd .%{gem_instdir}

# Fix wrong shebang
#grep -rl /usr/local/bin sample | \
#	xargs sed -i -e 's|/usr/local/bin|/usr/bin|'

# Kill shebang
grep -rl '#!.*/usr/bin' sample | \
	xargs sed -i -e '\@#![ ]*/usr/bin@d'
find sample/ -name \*.rb | xargs chmod 0644
popd

%build
# Move C extension library to some private directory
pushd .%{gem_instdir}
%if ! %{ruby19}
mkdir lib/ruby-gnome2
mv lib/%{gem_name}.so lib/ruby-gnome2/
grep -rl '%{gem_name}.so' . | \
	xargs sed -i \
		-e "\@require@s|'%{gem_name}.so'|'ruby-gnome2/%{gem_name}.so'|" \
		-e '\@require@s|"%{gem_name}.so"|"ruby-gnome2/%{gem_name}.so"|'
%endif

# Fix up Rakefile for "gnome2-raketask" requirement
sed -i -e "/require.*gnome2-raketask/s|^\(.*\)|begin\n  \1\nrescue LoadError\n  require 'rubygems'\n  require 'gnome2-raketask'\nend\n|" \
	Rakefile

%install
# Once copy all
mkdir -p %{buildroot}%{gem_dir}
cp -a .%{gem_dir}/* \
	%{buildroot}%{gem_dir}/

pushd %{buildroot}
# move header files, C extension files to the correct directory
%if ! %{ruby19}
mkdir -p .%{ruby_sitearch}/ruby-gnome2
mv .%{gem_instdir}/lib/ruby-gnome2/%{gem_name}.so .%{ruby_sitearch}/ruby-gnome2/
%else
mkdir -p .%{gem_extdir}/lib
mv .%{gem_instdir}/lib/%{gem_name}.so .%{gem_extdir}/lib
%endif
# mv .%%{gem_instdir}/lib/*.h .%%{ruby_sitearch}/
popd

# move pkgconfig file
mkdir %{buildroot}%{_libdir}/pkgconfig
install -cpm 644 ./%{_libdir}/pkgconfig/*.pc \
	%{buildroot}%{_libdir}/pkgconfig/


# Cleanups
pushd %{buildroot}
rm -rf .%{gem_instdir}/ext/
rm -f .%{gem_instdir}/extconf.rb
popd

%if 0%{?fedora} < 16
# The following method is completely copied from rubygem-gettext
# spec file
#
# Create symlinks
##
## Note that before switching to gem %%{ruby_sitelib}/%%{gem_name}
## already existed as a directory, so this cannot be replaced
## by symlink (cpio fails)
## Similarly, all directories under %%{ruby_sitelib} cannot be
## replaced by symlink
#

create_symlink_rec(){

ORIGBASEDIR=$1
TARGETBASEDIR=$2

## First calculate relative path of ORIGBASEDIR 
## from TARGETBASEDIR
TMPDIR=$TARGETBASEDIR
BACKDIR=
DOWNDIR=
num=0
nnum=0
while true
do
	num=$((num+1))
	TMPDIR=$(echo $TMPDIR | sed -e 's|/[^/][^/]*$||')
	DOWNDIR=$(echo $ORIGBASEDIR | sed -e "s|^$TMPDIR||")
	if [ x$DOWNDIR != x$ORIGBASEDIR ]
	then
		nnum=0
		while [ $nnum -lt $num ]
		do
			BACKDIR="../$BACKDIR"
			nnum=$((nnum+1))
		done
		break
	fi
done

RELBASEDIR=$( echo $BACKDIR/$DOWNDIR | sed -e 's|//*|/|g' )

## Next actually create symlink
pushd %{buildroot}/$ORIGBASEDIR
find . -type f | while read f
do
	DIRNAME=$(dirname $f)
	BACK2DIR=$(echo $DIRNAME | sed -e 's|/[^/][^/]*|/..|g')
	mkdir -p %{buildroot}${TARGETBASEDIR}/$DIRNAME
	LNNAME=$(echo $BACK2DIR/$RELBASEDIR/$f | \
		sed -e 's|^\./||' | sed -e 's|//|/|g' | \
		sed -e 's|/\./|/|' )
	ln -s -f $LNNAME %{buildroot}${TARGETBASEDIR}/$f
done
popd

}

create_symlink_rec %{gem_instdir}/lib %{ruby_sitelib}
%endif

%check
# Currently no testsuite available

%files
%dir	%{gem_instdir}
%dir	%{gem_instdir}/lib/

%doc	%{gem_instdir}/[A-Z]*
%exclude	%{gem_instdir}/Rakefile

%{gem_instdir}/lib/%{gem_name}.rb
%if %{ruby19}
%dir	%{gem_extdir}
%dir	%{gem_extdir}/lib
%{gem_extdir}/lib/%{gem_name}.so
%else
# %%ruby_sitearch/ruby-gnome2 is owned by rubygem-glib2
%{ruby_sitearch}/ruby-gnome2/%{gem_name}.so
%endif

%{gem_cache}
%{gem_spec}

%if 0%{?fedora} < 16
%files	-n ruby-%{gem_name}
%defattr(-,root,root,-)
%{ruby_sitelib}/*.rb
%endif

%files	devel
%defattr(-,root,root,-)
%{_libdir}/pkgconfig/ruby-%{gem_name}.pc

%files	doc
%defattr(-,root,root,-)
%{gem_docdir}/
%{gem_instdir}/Rakefile
%{gem_instdir}/sample/

%changelog
* Wed Sep  5 2012 Mamoru Tasaka <mtasaka@fedoraproject.org> - 1.1.5-1
- 1.1.5

* Mon Aug 13 2012 Mamoru Tasaka <mtasaka@fedoraproject.org> - 1.1.4-1
- 1.1.4

* Sat Jul 21 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.1.3-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Mon Apr 16 2012 Mamoru Tasaka <mtasaka@fedoraproject.org> - 1.1.3-2
- 1.1.3

* Tue Jan 31 2012 Mamoru Tasaka <mtasaka@fedoraproject.org> - 1.1.2-2
- 1.1.2

* Sun Jan 15 2012 Mamoru Tasaka <mtasaka@fedoraproject.org> - 1.1.1-1
- 1.1.1

* Sat Jan 14 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.3-3
- F-17: Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Fri Dec 23 2011 Mamoru Tasaka <mtasaka@fedoraproject.org> - 1.0.3-2
- Fix Obsoletes condition

* Thu Dec 22 2011 Mamoru Tasaka <mtasaka@fedoraproject.org> - 1.0.3-1
- 1.0.3

* Sun Jul 17 2011 Mamoru Tasaka <mtasaka@fedoraproject.org> - 1.0.0-1
- 1.0.0
- Kill non-gem support on F-16+

* Sun Apr 10 2011 Mamoru Tasaka <mtasaka@fedoraproject.org> - 0.90.8-2
- Some cleanups

* Thu Mar 10 2011 Mamoru Tasaka <mtasaka@fedoraproject.org> - 0.90.8-1
- 0.90.8

* Sat Feb 19 2011 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.90.7-2
- Initial package

